/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnCallOffered - Invoked when an inbound call is offered. (INVITE)    OnCallAccepted - Invoked when an inbound call is accepted. (RINGING)    OnCallAnswered - Invoked when an inbound call is answered. (OK)    OnCallCancelled - Invoked when an inbound call is disconnected before it is answered. (CANCEL)
    /// </summary>
    [DataContract]
        public partial class InboundCallsSubscriptions :  IEquatable<InboundCallsSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InboundCallsSubscriptions" /> class.
        /// </summary>
        /// <param name="onCallOffered">onCallOffered.</param>
        /// <param name="onCallAccepted">onCallAccepted.</param>
        /// <param name="onCallAnswered">onCallAnswered.</param>
        /// <param name="onCallCancelled">onCallCancelled.</param>
        public InboundCallsSubscriptions(string onCallOffered = default(string), string onCallAccepted = default(string), string onCallAnswered = default(string), string onCallCancelled = default(string))
        {
            this.OnCallOffered = onCallOffered;
            this.OnCallAccepted = onCallAccepted;
            this.OnCallAnswered = onCallAnswered;
            this.OnCallCancelled = onCallCancelled;
        }
        
        /// <summary>
        /// Gets or Sets OnCallOffered
        /// </summary>
        [DataMember(Name="onCallOffered", EmitDefaultValue=false)]
        public string OnCallOffered { get; set; }

        /// <summary>
        /// Gets or Sets OnCallAccepted
        /// </summary>
        [DataMember(Name="onCallAccepted", EmitDefaultValue=false)]
        public string OnCallAccepted { get; set; }

        /// <summary>
        /// Gets or Sets OnCallAnswered
        /// </summary>
        [DataMember(Name="onCallAnswered", EmitDefaultValue=false)]
        public string OnCallAnswered { get; set; }

        /// <summary>
        /// Gets or Sets OnCallCancelled
        /// </summary>
        [DataMember(Name="onCallCancelled", EmitDefaultValue=false)]
        public string OnCallCancelled { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InboundCallsSubscriptions {\n");
            sb.Append("  OnCallOffered: ").Append(OnCallOffered).Append("\n");
            sb.Append("  OnCallAccepted: ").Append(OnCallAccepted).Append("\n");
            sb.Append("  OnCallAnswered: ").Append(OnCallAnswered).Append("\n");
            sb.Append("  OnCallCancelled: ").Append(OnCallCancelled).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InboundCallsSubscriptions);
        }

        /// <summary>
        /// Returns true if InboundCallsSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of InboundCallsSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InboundCallsSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnCallOffered == input.OnCallOffered ||
                    (this.OnCallOffered != null &&
                    this.OnCallOffered.Equals(input.OnCallOffered))
                ) && 
                (
                    this.OnCallAccepted == input.OnCallAccepted ||
                    (this.OnCallAccepted != null &&
                    this.OnCallAccepted.Equals(input.OnCallAccepted))
                ) && 
                (
                    this.OnCallAnswered == input.OnCallAnswered ||
                    (this.OnCallAnswered != null &&
                    this.OnCallAnswered.Equals(input.OnCallAnswered))
                ) && 
                (
                    this.OnCallCancelled == input.OnCallCancelled ||
                    (this.OnCallCancelled != null &&
                    this.OnCallCancelled.Equals(input.OnCallCancelled))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnCallOffered != null)
                    hashCode = hashCode * 59 + this.OnCallOffered.GetHashCode();
                if (this.OnCallAccepted != null)
                    hashCode = hashCode * 59 + this.OnCallAccepted.GetHashCode();
                if (this.OnCallAnswered != null)
                    hashCode = hashCode * 59 + this.OnCallAnswered.GetHashCode();
                if (this.OnCallCancelled != null)
                    hashCode = hashCode * 59 + this.OnCallCancelled.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
